/*
 * Spinano (alias PEspin Nanomites fixer) source code by Zool@nder of AT4RE
 * This source is for educational purpose.
 *
 *
 * compiled successfully under window xp sp2 + MinGW-4.4.1.
 * for extreme beginner, compiler like this:
 *  gcc  -c  main.c  -funsigned-char  -o main.o -IC:/MinGW-4.4.1/include
 * and link like this:
 *  gcc -o spinano.exe main.o  -LC:/MinGW-4.4.1/lib  -lollydisasm
 *
 *
 * You will notice that I often rename variable to reflect their true meanning
 *   to help you understand the steps protector's using to fix nanomites, so
 *   things like 'delta = ns->dword0;' then '*(UINT *)(pos + 2) = delta;' or
 *   may appear ugly, but it's intentional.
 * Also consider that this is an old source code witch I tried to reanimate and
 *   comment to let you understand the steps of nanomites fixing.
 *   The initial code was wrote in a harry with one aim -> fix the nanos and not
 *   win the world biggest price of code beauty ;)
 *
 *
 * Zool@nder of Da great AT4RE
 * 6/27/2011
 *
 * Have fun
 */


#include <windows.h>
#include "resource.h"
#include "disasm.h"
#include "main.h"


fixerProto pFuncToCall[8] = {
	FuncFix_MOV_R_M,
	FuncFix_MOV_R_R,
	FuncFix_MOV_M_R,
	FuncFix_JE_JNE,
	FuncFix_JB_JNB,
	FuncFix_JMP_TABLE,
	FuncFix_JA_JBE,
	NULL
};

char* regs[] = {
	"eax",
	"ecx",
	"edx",
	"ebx",
	"esp",
	"ebp",
	"esi",
	"edi"
};

char* cmds[] = {
	"or",
	"and",
	"xor",
	"add",
	"sub",
	"mov"

};

HANDLE hFile = 0;
HANDLE hFileMap = 0;
LPVOID hMap = 0;
HWND ghwnd = 0;

// target info
int bSectAdded = 0; // default : no section added
int pespinVersion = 133; // default : version 1.33

// sections info
IMAGE_SECTION_HEADER *pSectionsHeaders;
int nSections = 0;
UINT firstSectBegin = 0;
UINT firstSectEnd = 0;

// nanos info
nanostruct *pNanoStructs;
UINT nNanos = 0;
UINT imageBase = 0;

void print(const char msg[MAX_PATH], UINT addr) {
	char buffer[MAX_PATH+10];

	wsprintf(buffer, msg, addr);
	SendDlgItemMessage(ghwnd, IDC_LIST1, LB_ADDSTRING, 0, (LPARAM) buffer);
}

UINT OffsetToRVA(UINT offset) {
	int i = 0;

	if (offset < pSectionsHeaders->PointerToRawData)
		return offset;

	for (i = 0; i < nSections; ++i) {
		if (offset >= pSectionsHeaders[i].PointerToRawData && offset < pSectionsHeaders[i].PointerToRawData + pSectionsHeaders[i].SizeOfRawData)
			return pSectionsHeaders[i].VirtualAddress + offset - pSectionsHeaders[i].PointerToRawData;
	}
	return -1;

}

UINT OffsetToVA(UINT offset) {
	return imageBase + OffsetToRVA(offset);
}

int RVAToOffset(UINT rva) {
	int i = 0;

	if (rva < pSectionsHeaders->VirtualAddress)
		return rva;

	for (i = 0; i < nSections; ++i) {
		if (rva >= pSectionsHeaders[i].VirtualAddress && rva < pSectionsHeaders[i].VirtualAddress + pSectionsHeaders[i].Misc.PhysicalAddress)
			return pSectionsHeaders[i].PointerToRawData + rva - pSectionsHeaders[i].VirtualAddress;
	}
	return -1;
}

void GetPointerAndOtherStuff(IMAGE_DOS_HEADER *idh) {
	IMAGE_NT_HEADERS32 *inh = 0;
	BYTE* dummy = 0;
	BYTE* mapBase = (BYTE*) hMap;

	if (idh->e_magic == 'ZM') {
		inh = (IMAGE_NT_HEADERS32 *)(mapBase + idh->e_lfanew);
		if (LOWORD(inh->Signature) == 'EP') {
			inh = (IMAGE_NT_HEADERS32 *)((char *)idh + idh->e_lfanew);
			nSections = inh->FileHeader.NumberOfSections;
			pSectionsHeaders = (IMAGE_SECTION_HEADER*) ((char*)inh + sizeof(IMAGE_NT_HEADERS));
			imageBase = inh->OptionalHeader.ImageBase;

			// Pointer to Last Section of original proggy that contains loader.
			dummy = mapBase
			        + RVAToOffset(pSectionsHeaders[nSections - bSectAdded - 1].VirtualAddress)
			        + ((pespinVersion == 132) ? DELTA132 : DELTA133);
			pNanoStructs = (nanostruct *)(mapBase + RVAToOffset(*(UINT *)dummy - imageBase));
			nNanos = *(UINT *)(dummy + 5) / 0xB;
			firstSectBegin = (UINT)(mapBase + RVAToOffset(pSectionsHeaders->VirtualAddress));
			firstSectEnd = firstSectBegin + pSectionsHeaders->Misc.PhysicalAddress - 1;
		}
		else {
			print("Not a valid PE", 0);
			CloseMapFile();
		}
	}
	else {
		print("Not a valid PE", 0);
		CloseMapFile();
	}
}

UINT AddressHasher(UINT pos) {
	int i = 0, j = 0;
	UINT hash = 0, tmp0 = 0;
	char dummybuffer[TEXTLEN];

	UINT va = OffsetToVA(pos - (UINT)hMap);
	wsprintf(dummybuffer, "%.08X", va);

	for(i = 0, tmp0 = 0, hash = -1; dummybuffer[i]; i++) {
		hash ^= dummybuffer[i];

		for(j = 8; j; j--) {
			tmp0 = hash & 1;
			hash >>= 1;
			if (tmp0)
				hash ^= 0xEDB88320;
		}
	}

	return hash;
}

UINT FixNanomites() {
	UINT hash = 0;
	int i = 0, nNanosFixed = 0;
	UINT pos = firstSectBegin;

	while (pos < firstSectEnd) {
		if (*(WORD *) pos == 0xC08D) { // if it's nano alias 'lea eax, eax'
			hash = AddressHasher(pos);

			i = 0;
			while (i < nNanos) {
				if (hash == pNanoStructs[i].nanoApiHash
				        && pNanoStructs[i].pNanoProcIndex >= 0
				        && pNanoStructs[i].pNanoProcIndex < 8) {

					((void (__stdcall *)(nanostruct*, UINT))pFuncToCall[pNanoStructs[i].pNanoProcIndex])(pNanoStructs + i, pos);
					nNanosFixed++;
					break;
				}
				i++;
			}
		}
		++pos;
	}

	return nNanosFixed;
}

void FuncFix_JA_JBE(nanostruct *ns, BYTE *pos) {
	int jmpOpcode = ns->db0;
	UINT delta = ns->dword0;

	if (ns->db1 == JUMPTYPE_SHORT) { 			// short jump
		pos[1] = delta;

		// JUMPOPCODE_JBE
		if (jmpOpcode == JUMPOPCODE_JBE)
			*pos = 0x76;

		// JUMPOPCODE_JA
		else
			*pos = 0x77;
	}
	else if (ns->db1 == JUMPTYPE_LONG) {
		*(UINT *)(pos + 2) = delta;

		// JUMPOPCODE_JBE
		if (jmpOpcode == JUMPOPCODE_JBE)
			*(WORD *)pos = 0x860F;

		// JUMPOPCODE_JA
		else
			*(WORD *)pos = 0x870F;
	}
	print("'Cond/Uncond jump' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

void FuncFix_JB_JNB(nanostruct *ns, LPBYTE pos) {
	int jmpOpcode = ns->db0;
	UINT delta = ns->dword0;

	if (ns->db1 == JUMPTYPE_SHORT) {
		pos[1] = delta;
		if (jmpOpcode == JUMPOPCODE_JB)
			*pos = 0x72;
		else
			*pos = 0x73;
	}
	else if (ns->db1 == JUMPTYPE_LONG) {
		*(UINT *)(pos + 2) = delta;
		if (jmpOpcode == JUMPOPCODE_JB)
			*(WORD *)pos = 0x820F;
		else
			*(WORD *)pos = 0x830F;
	}
	print("'Cond/Uncond jump' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

void FuncFix_JE_JNE(nanostruct *ns, LPBYTE pos) {
	int jmpOpcode = ns->db0;
	UINT delta = ns->dword0;

	if (ns->db1 == JUMPTYPE_SHORT) {
		pos[1] = delta;
		if (jmpOpcode)
			*pos = 0x75;
		else
			*pos = 0x74;
	}
	else if (ns->db1 == JUMPTYPE_LONG) {
		*(UINT *)(pos + 2) = delta;
		if (jmpOpcode)
			*(WORD *)pos = 0x850F;
		else
			*(WORD *)pos = 0x840F;
	}
	print("'Cond/Uncond jump' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

void FuncFix_JMP_TABLE(nanostruct *ns, LPBYTE pos) {
	char sCmdBuffer[80] = {0}, errbuffer[TEXTLEN];
	t_asmmodel tasm;

	wsprintf(sCmdBuffer, "jmp dword ptr ds:[%s*4+%.09X]", regs[ns->db0 & 7], ns->dword0);
	Assemble(sCmdBuffer, OffsetToVA((UINT)pos), &tasm, 0, 0, errbuffer);
	CopyMemory(pos, &tasm.code + 1, 7);
	print("'jump table' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

void FuncFix_MOV_M_R(nanostruct *ns, LPBYTE pos) {
	char sCmdBuffer[80] = {0}, errbuffer[TEXTLEN];
	t_asmmodel tasm;

	wsprintf(sCmdBuffer, "mov dword ptr ds:[%s], %.09X", regs[ns->db0], ns->dword0);
	Assemble(sCmdBuffer, 0, &tasm, 0, 0, errbuffer);
	CopyMemory(pos, &tasm, ns->db1);
	print("'mov [mem], R32' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

void FuncFix_MOV_R_M(nanostruct *ns, LPBYTE pos) {
	char sCmdBuffer[TEXTLEN] = {0}, errbuffer[TEXTLEN] = {0}, binCmdBuffer[MAXCMDSIZE] = {0};
	t_asmmodel tasm;
	int i = 0, len = 0, cst = 0;

	int iDestination = (ns->db0 >> 3) & 7;
	int iSource = ns->db0 & 7;

	const char* cmd = 0;

	if (ns->db1 == 3 && ns->dword0 > 0x7F) {
		cst = -ns->dword0 & 0xFF;
		if (iSource == 4 || iSource == 5)
			cmd = "mov %s, dword ptr ss:[%s-%.09X]";
		else
			cmd = "mov %s, dword ptr ds:[%s-%.09X]";
	}
	else {
		cst = ns->dword0;
		if (iSource == 4 || iSource == 5)
			cmd = "mov %s, dword ptr ss:[%s+%.09X]";
		else
			cmd = "mov %s, dword ptr ds:[%s+%.09X]";
	}

	wsprintf(sCmdBuffer, cmd, regs[iDestination], regs[iSource], cst);

	// we have to obtain the shortest optimized version of the instruction so instructions don't overlap after fixing 'em
	for (i = 0, len = MAXCMDSIZE; i < 4 ; i++) {
		Assemble(sCmdBuffer, 0, &tasm, 0, i, errbuffer);
		if(len > tasm.length) {
			memcpy(binCmdBuffer, tasm.code, tasm.length);
			len = tasm.length;
		}
	}

	CopyMemory(pos, binCmdBuffer, len);
	print("'mov R32, [mem]' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

void FuncFix_MOV_R_R(nanostruct *ns, LPBYTE pos) {
	char sCmdBuffer[80] = {0}, errbuffer[TEXTLEN] = {0};
	t_asmmodel tasm;

	int iDestination = (ns->db0 >> 4) /* & 0xF */;
	int iSource = ns->db0 & 0xF;

	wsprintf(sCmdBuffer, "%s %s, %s", cmds[ns->dword0], regs[iDestination], regs[iSource]);
	Assemble(sCmdBuffer, 0, &tasm, 0, 0, errbuffer);
	CopyMemory(pos, &tasm, ns->db1);
	print("'mov R32, R32' at address:%08X", OffsetToVA((UINT)pos - (UINT)hMap));
}

BOOL OpenMapFile( BOOL bSaveBkp ) {

	char pathExe[MAX_PATH];
	char pathBkp[MAX_PATH];
	OPENFILENAME ofn;

	RtlZeroMemory (&ofn, sizeof (OPENFILENAME));
	ofn.lStructSize = sizeof (OPENFILENAME);
	ofn.hwndOwner = ghwnd;
	ofn.lpstrFilter = "executables (*.exe)\x0*.exe\x0\x0";
	ofn.lpstrFile = pathExe;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_EXPLORER;

	if(GetOpenFileName(&ofn)) {
		if(bSaveBkp) {
			lstrcpy(pathBkp, pathExe);
			lstrcat(pathBkp, "_");
			CopyFile(pathExe, pathBkp, FALSE);
		}

		hFile = CreateFile (pathExe, // path_to_target
		                    GENERIC_WRITE | GENERIC_READ,
		                    FILE_SHARE_READ | FILE_SHARE_DELETE | FILE_SHARE_WRITE,
		                    0, OPEN_EXISTING,
		                    FILE_ATTRIBUTE_NORMAL,
		                    0);
		if (hFile ==  INVALID_HANDLE_VALUE)
			print("can't open file", 0);
		else {
			hFileMap = CreateFileMapping (hFile, 0, PAGE_READWRITE, 0, 0, 0);
			if (hFileMap) {
				hMap = MapViewOfFile (hFileMap, FILE_MAP_WRITE | FILE_MAP_READ, 0, 0, 0);
				if (!hMap) {
					print("can't map file", 0);
					CloseHandle (hFile);
					CloseHandle (hFileMap);
				}
				else {
					print("file successfully mapped...", 0);
					return TRUE;
				}
			}
			else {
				print("can't map file", 0);
				CloseHandle (hFile);
			}
		}
	}

	return FALSE;
}

void CloseMapFile() {
	UnmapViewOfFile (hMap);
	CloseHandle (hFileMap);
	CloseHandle (hFile);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow) {
	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, (DLGPROC)DlgProc, (IDD_DIALOG1));
	return TRUE;
}

void PrintInfo() {
	print("Spinano v0.2 (a.k.a PEspin Nanomites fixer)", 0);
	print("Supports PEspin 1.32 and 1.33", 0);
	print("By Zool@nder of AT4RE (27.06.2011)", 0);
	print(" ", 0);
}

BOOL CALLBACK DlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	char buffer[MAX_PATH];
	UINT nFixedNanos = 0;

	switch(uMsg) {
		case WM_INITDIALOG:
			ghwnd = hwnd;
			PrintInfo();

			CheckRadioButton(hwnd, IDC_RADIO1, IDC_RADIO1, IDC_RADIO2);
			CheckDlgButton(hwnd, IDC_CHECKBOX1, BST_CHECKED);
			CheckDlgButton(hwnd, IDC_CHECKBOX2, BST_CHECKED);
			CheckDlgButton(hwnd, IDC_RADIO2, BST_CHECKED);
			break;

		case WM_COMMAND:
			switch(HIWORD(wParam)) {
				case BN_CLICKED: {
					switch(LOWORD(wParam)) {
						case ID_CANCEL: {
							SendMessage(hwnd, WM_CLOSE, 0, 0);
						}
						break;

						case ID_OK: {
							SendDlgItemMessage(hwnd, IDC_LIST1, LB_RESETCONTENT, 0, 0);
							PrintInfo();
							
							// Get settings
							bSectAdded = IsDlgButtonChecked(hwnd, IDC_CHECKBOX1);
							pespinVersion = (IsDlgButtonChecked(hwnd, IDC_RADIO1)) ? 132 : 133;
							
							if(OpenMapFile(IsDlgButtonChecked(hwnd, IDC_CHECKBOX2))) {
								GetPointerAndOtherStuff((IMAGE_DOS_HEADER*) hMap);
								wsprintf(buffer, "%d/%d nanos were fixed", FixNanomites(), nNanos);
								print(buffer, 0);
								CloseMapFile();
							}
						}
					}
				}
			}
			break;

		case WM_CLOSE:
			EndDialog(hwnd, FALSE);
			break;

		default:
			return FALSE;
	}
	return TRUE;
}
